// Copyright 2012 the V8 project authors. All rights reserved.
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above
//       copyright notice, this list of conditions and the following
//       disclaimer in the documentation and/or other materials provided
//       with the distribution.
//     * Neither the name of Google Inc. nor the names of its
//       contributors may be used to endorse or promote products derived
//       from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include "v8.h"
#include <assert.h>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>

void download(const char *url, std::vector<uint8_t> &data);

v8::Handle<v8::Context> CreateShellContext(v8::Isolate* isolate);
int RunMain(v8::Isolate* isolate, int argc, char* argv[]);
bool ExecuteString(v8::Isolate* isolate,
                   v8::Handle<v8::String> source,
                   v8::Handle<v8::Value> name,
                   bool print_result,
                   bool report_exceptions);
void Print(const v8::FunctionCallbackInfo<v8::Value>& args);
void PrintError(const v8::FunctionCallbackInfo<v8::Value>& args);
void GetPDFArrayBuffer(const v8::FunctionCallbackInfo<v8::Value>& args);
v8::Handle<v8::String> ReadFile(v8::Isolate* isolate, const char* name);
void ReportException(v8::Isolate* isolate, v8::TryCatch* handler);

v8::Handle<v8::ArrayBuffer> pdfArrayBuffer;

std::string *extracted_text = 0;

class ShellArrayBufferAllocator : public v8::ArrayBuffer::Allocator {
 public:
  virtual void* Allocate(size_t length) {
    void* result = malloc(length);
    memset(result, 0, length);
    return result;
  }
  virtual void* AllocateUninitialized(size_t length) {
    return malloc(length);
  }
  virtual void Free(void* data, size_t) { free(data); }
  // TODO(dslomov): Remove when v8:2823 is fixed.
  virtual void Free(void* data) {
  }
};

#if 0
size_t write_data(void *buf, size_t sz, size_t nmemb, void *ud){
	size_t segsize = sz * nmemb;
	std::vector<uint8_t> *dary = static_cast<std::vector<uint8_t> *>(ud);
	uint8_t *begin = static_cast<uint8_t *>(buf);
	dary->insert(dary->end(), begin, begin + segsize);
	return segsize;
}
#endif

struct pdf_js_initialize{
	ShellArrayBufferAllocator array_buffer_allocator;
	pdf_js_initialize(){
		v8::V8::SetArrayBufferAllocator(&array_buffer_allocator);
		v8::V8::InitializeICU();
	}
}pji;

void parse_pdf(const char *url_pdf, std::string &content){
	extracted_text = &content;

//	v8::V8::SetFlagsFromCommandLine(&argc, argv, true);
	v8::Isolate* isolate = v8::Isolate::GetCurrent();
	int result = 0;

	v8::HandleScope handle_scope(isolate);
	v8::Handle<v8::Context> context = CreateShellContext(isolate);
	if (context.IsEmpty()) {
		std::fprintf(stderr, "Error creating context\n");
		return;
	}
	context->Enter();

#if 0
	FILE *fp = std::fopen(argv[1], "rb");
	std::fseek(fp, 0, SEEK_END);
	size_t sz = std::ftell(fp);
	std::rewind(fp);
	void *buf = array_buffer_allocator.Allocate(sz);
	std::fread(buf, sz, 1, fp);
	std::fclose(fp);
#else
	std::vector<uint8_t> dary;
	download(url_pdf, dary);
	void *buf = pji.array_buffer_allocator.Allocate(dary.size());
	std::memcpy(buf, &dary[0], dary.size());
	size_t sz = dary.size();
#endif
	pdfArrayBuffer = v8::ArrayBuffer::New(isolate, buf, sz);

	char *files[] = {"",
		"postMessage.js", "pdf.js", "pdf.worker.js", "pdf2text.js", "messageLoop.js", 0
	};
	int nfiles = 0;
	for (char **p = files; *p; ++p) ++nfiles;
	result = RunMain(isolate, nfiles, files);
    context->Exit();
}


// Extracts a C string from a V8 Utf8Value.
const char* ToCString(const v8::String::Utf8Value& value) {
  return *value ? *value : "<string conversion failed>";
}

// Creates a new execution environment containing the built-in
// functions.
v8::Handle<v8::Context> CreateShellContext(v8::Isolate* isolate) {
  // Create a template for the global object.
  v8::Handle<v8::ObjectTemplate> global = v8::ObjectTemplate::New(isolate);
  // Bind the global 'print' function to the C++ Print callback.
  global->Set(v8::String::NewFromUtf8(isolate, "print"),
              v8::FunctionTemplate::New(isolate, Print));
  // Bind the global 'printerror' function to the C++ PrintError callback.
  global->Set(v8::String::NewFromUtf8(isolate, "printerror"),
              v8::FunctionTemplate::New(isolate, PrintError));
  // Bind the 'loadPDFData' function
  global->Set(v8::String::NewFromUtf8(isolate, "getPDFArrayBuffer"),
              v8::FunctionTemplate::New(isolate, GetPDFArrayBuffer));

  return v8::Context::New(isolate, NULL, global);
}

// The callback that is invoked by v8 whenever the JavaScript 'print'
// function is called.  Prints its arguments on stdout separated by
// spaces and ending with a newline.
void Print(const v8::FunctionCallbackInfo<v8::Value>& args) {
	bool first = true;
	for (int i = 0; i < args.Length(); i++) {
		v8::HandleScope handle_scope(args.GetIsolate());
		if (first) first = false;
		else (*extracted_text) += ' ';
		v8::String::Utf8Value str(args[i]);
		(*extracted_text) += ToCString(str);
	}
	(*extracted_text) += "\n";
}

void PrintError(const v8::FunctionCallbackInfo<v8::Value>& args) {
  bool first = true;
  for (int i = 0; i < args.Length(); i++) {
    v8::HandleScope handle_scope(args.GetIsolate());
    if (first) {
      first = false;
    } else {
		std::fprintf(stderr, " ");
    }
    v8::String::Utf8Value str(args[i]);
    const char* cstr = ToCString(str);
	std::fprintf(stderr, "%s", cstr);
  }
  std::fprintf(stderr, "\n");
  std::fflush(stderr);
}

void GetPDFArrayBuffer(const v8::FunctionCallbackInfo<v8::Value>& args){
  args.GetReturnValue().Set(pdfArrayBuffer);
}

// Reads a file into a v8 string.
v8::Handle<v8::String> ReadFile(v8::Isolate* isolate, const char* name) {
	FILE* file = std::fopen(name, "rb");
  if (file == NULL) return v8::Handle<v8::String>();

  fseek(file, 0, SEEK_END);
  int size = ftell(file);
  rewind(file);

  char* chars = new char[size + 1];
  chars[size] = '\0';
  for (int i = 0; i < size;) {
    int read = static_cast<int>(fread(&chars[i], 1, size - i, file));
    i += read;
  }
  fclose(file);
  v8::Handle<v8::String> result =
      v8::String::NewFromUtf8(isolate, chars, v8::String::kNormalString, size);
  delete[] chars;
  return result;
}


// Process remaining command line arguments and execute files
int RunMain(v8::Isolate* isolate, int argc, char* argv[]) {
  for (int i = 1; i < argc; i++) {
    const char* str = argv[i];
    // Use all other arguments as names of files to load and run.
    v8::Handle<v8::String> file_name = v8::String::NewFromUtf8(isolate, str);
    v8::Handle<v8::String> source = ReadFile(isolate, str);
    if (source.IsEmpty()) {
	 std::fprintf(stderr, "Error reading '%s'\n", str);
      continue;
    }
    if (!ExecuteString(isolate, source, file_name, false, true)) return 1;
  }
  return 0;
}


// Executes a string within the current v8 context.
bool ExecuteString(v8::Isolate* isolate,
                   v8::Handle<v8::String> source,
                   v8::Handle<v8::Value> name,
                   bool print_result,
                   bool report_exceptions) {
  v8::HandleScope handle_scope(isolate);
  v8::TryCatch try_catch;
  v8::ScriptOrigin origin(name);
  v8::Handle<v8::Script> script = v8::Script::Compile(source, &origin);
  if (script.IsEmpty()) {
    // Print errors that happened during compilation.
    if (report_exceptions)
      ReportException(isolate, &try_catch);
    return false;
  } else {
    v8::Handle<v8::Value> result = script->Run();
    if (result.IsEmpty()) {
      assert(try_catch.HasCaught());
      // Print errors that happened during execution.
      if (report_exceptions)
        ReportException(isolate, &try_catch);
      return false;
    } else {
      assert(!try_catch.HasCaught());
      if (print_result && !result->IsUndefined()) {
        // If all went well and the result wasn't undefined then print
        // the returned value.
        v8::String::Utf8Value str(result);
        const char* cstr = ToCString(str);
		std::printf("%s\n", cstr);
      }
      return true;
    }
  }
}


void ReportException(v8::Isolate* isolate, v8::TryCatch* try_catch) {
  v8::HandleScope handle_scope(isolate);
  v8::String::Utf8Value exception(try_catch->Exception());
  const char* exception_string = ToCString(exception);
  v8::Handle<v8::Message> message = try_catch->Message();
  if (message.IsEmpty()) {
    // V8 didn't provide any extra information about this error; just
    // print the exception.
	  std::fprintf(stderr, "%s\n", exception_string);
  } else {
    // Print (filename):(line number): (message).
    v8::String::Utf8Value filename(message->GetScriptResourceName());
    const char* filename_string = ToCString(filename);
    int linenum = message->GetLineNumber();
	std::fprintf(stderr, "%s:%i: %s\n", filename_string, linenum, exception_string);
    // Print line of source code.
    v8::String::Utf8Value sourceline(message->GetSourceLine());
    const char* sourceline_string = ToCString(sourceline);
	std::fprintf(stderr, "%s\n", sourceline_string);
    // Print wavy underline (GetUnderline is deprecated).
    int start = message->GetStartColumn();
    for (int i = 0; i < start; i++) {
		std::fprintf(stderr, " ");
    }
    int end = message->GetEndColumn();
    for (int i = start; i < end; i++) {
		std::fprintf(stderr, "^");
    }
	std::fprintf(stderr, "\n");
    v8::String::Utf8Value stack_trace(try_catch->StackTrace());
    if (stack_trace.length() > 0) {
      const char* stack_trace_string = ToCString(stack_trace);
	  std::fprintf(stderr, "%s\n", stack_trace_string);
    }
  }
}
